--[[
************************************************************************
Project				: Broker_Extractor
Author				: zhinjio
Project Revision	: r31
Project Date		: 20090430213358

File				: Broker_Extractor.lua
Commit Author		: zhinjio
Commit Revision		: 31
Commit Date			: 20090430213358
************************************************************************
Description	:
	Main addon file. 

TODO		:

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

local MODNAME = "Extractor"
local FULLNAME = "Broker_Extractor"
local Extractor = LibStub( "AceAddon-3.0" ):NewAddon( MODNAME, "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( MODNAME )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")

_G[ MODNAME ] = Extractor
local addon = Extractor

local addonversion = "r31"
local addonauthor = "zhinjio"
local builddate = "20090430213358"

local modularOptions = {}
local tooltip
local LTT = LibStub:GetLibrary( "LibQTip-1.0" )

-- addon globals
-- addon.someValue = 0
addon.VERSION = 1.0
addon.me = ""
addon.currTT = 0
addon.show = false

local db

function addon.Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\" .. FULLNAME .. "\\icon:" .. fh .. "\124t"
	if ( msg ~= nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " " .. MODNAME .. " : " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function addon.Debug( msg )
	if ( msg ~= nil ) then
		if ( db.options.display.debug ) then
			addon.Print( "DEBUG: " .. msg )
		end
	end
end
-- my custom tooltips have particular herbs and zones in them. store those values here
addon.ttHerbs = {
	[1] = "22710 2447 765 2449 785 2450 2453 3820",
	[2] = "3355 3369 3356 3357 3818 3821 3358 3819",
	[3] = "8831 4625 8839 8838 8846 13464 8845 13463 13465 8836 13466 13467",
	[4] = "22785 22786 22787 22789 22792 22793 22791 36901 36904 36907 36906",
}
addon.ttOre = {
	[5] = "2770 2771 2772 3858 10620 rtv",
	[6] = "23424 23425 rad 36909 rcn 36912 rsn",
}

addon.ttZones = {
	[1] = "20 14 50 31 19 5 15 44 23 30 39 46 53 11 34 3 54 26 16 40 41",
	[2] = "46 40 16 49 3 54 26 12 2 1 41 17 42 6 22 47 4",
	[3]	= "41 6 43 35 42 8 22 47 33 56 4 51 25 21 52 18 10 38 55",
	[4] = "56 25 33 32 45 36 7 29 27 9 37 13 24 57 48 28",
	[51] = "15 14 19 20 5 50 31 46 11 30 53 23 34 39 49 40 3 16 26 12 54 2 41",
	[52] = "49 3 26 12 40 2 41 6 1 17 22 43 47 35 21 8 38 4 10 52 55 51 18",
	[61] = "25 56 7 36 45 32 33 29",
	[62] = "27 57 9 13 24 37 48 28",
}

-- coloring agents
--local function Orange ( text )
--	return "|cffdea51c" .. text .. "|r"
--end
local function Green ( text )	return "|cff00c000" .. text .. "|r"	end
local function Orange ( text )	return "|cffcf8107" .. text .. "|r" end
local function Brown ( text )	return "|cffcf8107" .. text .. "|r" end
local function Yellow( text )	return "|cffffff00" .. text .. "|r" end
local function White( text )	return "|cffffffff" .. text .. "|r" end
local function Grey( text )		return "|cff808080" .. text .. "|r" end
local function Pink( text )		return "|cffff8080" .. text .. "|r" end

local function HideTooltip()
	tooltip:SetScript( "OnLeave", nil )
	tooltip:Hide()
	tooltip:Clear()
	tooltip:SetColumnLayout( 1, "LEFT" )
end

local function advanceTip()
	addon.shown = false
	local dbod = db.options.display
	local newtip = 0
	for i = 1, 7 do
		newtip = ( ( addon.currTT + i - 1 ) % 6 ) + 1
		if ( ( newtip == 1 ) and  ( dbod.herb1 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 2 ) and  ( dbod.herb2 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 3 ) and  ( dbod.herb3 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 4 ) and  ( dbod.herb4 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 5 ) and  ( dbod.ore1 == true ) ) then addon.shown = true; break end
		if ( ( newtip == 6 ) and  ( dbod.ore2 == true ) ) then addon.shown = true; break end
	end
	addon.currTT = newtip
end

local function drawTooltip()
	local numColumns = 0
	tooltip:Hide()
	tooltip:Clear()
	if ( addon.shown == false ) then
		-- show the info tooltip instead
		addon.Debug( "infoTT" )
		tooltip:SetColumnLayout( 3, "LEFT", "CENTER", "RIGHT" )
		tooltip:AddHeader( MODNAME )
		tooltip:AddLine( " " )
		tooltip:AddLine( L["Author : "], " ", addonauthor )
		tooltip:AddLine( L["Version : "], " ", addonversion )
		tooltip:AddLine( L["Build Date : "], " ", builddate )
		tooltip:AddLine( L["Database Version : "], " ", db.options.display.dbVersion )
	elseif ( ( addon.currTT >= 1 ) and ( addon.currTT <= 4 ) ) then
		-- its an herb tooltip

		-- Figure out how many columns we're going to have, and setup the column layout
		local index = 1
		local colLayout = {}
		colLayout[1] = "LEFT"
		for i in string.gmatch( addon.ttHerbs[addon.currTT], "%d+") do
			table.insert( colLayout, "CENTER" ); index = index + 1
		end
		tooltip:SetColumnLayout( index, unpack( colLayout ) )
		numColumns = index

		-- These three lines will turn into headers later
		tooltip:AddHeader("a")
		tooltip:AddLine(" ")
		tooltip:AddHeader("b")

		-- here's the custom stuff
		local iconMap, zoneData = {}, {}
		local colorOrange, colorYellow, colorGreen, colorGrey = {}, {}, {}, {}
		iconMap[1] = " "
		colorOrange[1] = " "; colorYellow[1] = " "; colorGreen[1] = " "; colorGrey[1] = " "
		for i in string.gmatch( addon.ttHerbs[addon.currTT], "%d+") do
			local j = i + 0
			local itemName, _, _, _, _, _, _, _, _, icon = GetItemInfo(j)
			addon.Debug( i .. " : " .. icon )
			table.insert( iconMap, "|T" .. icon .. ":48|t" )
			table.insert( colorOrange, Orange( addon.nodeCounts[j]["orange"] ) )
			table.insert( colorYellow, Yellow( addon.nodeCounts[j]["yellow"] ) )
			table.insert( colorGreen, Green( addon.nodeCounts[j]["green"] ) )
			table.insert( colorGrey, Grey( addon.nodeCounts[j]["grey"] ) )
		end
		tooltip:AddLine( unpack( iconMap ) );
		tooltip:AddLine( unpack( colorOrange ) ); tooltip:AddLine( unpack( colorYellow ) ) 
		tooltip:AddLine( unpack( colorGreen ) ); tooltip:AddLine( unpack( colorGrey ) )
		for i in string.gmatch( addon.ttZones[addon.currTT], "%d+") do
			j = i + 0
			zoneData = {}; zoneData[1] = Pink( addon.ZoneMapping[j] )
			for k in string.gmatch( addon.ttHerbs[addon.currTT], "%d+") do
				local m = k + 0
				if ( addon.nodeCounts[m][j] ) then
					table.insert( zoneData, addon.nodeCounts[m][j] )
				else
					table.insert( zoneData, " " )
				end
			end
			tooltip:AddLine( unpack ( zoneData ) )				
		end
		tooltip:SetCell( 1, 1, MODNAME, "CENTER", numColumns )
		tooltip:SetCell( 3, 1, string.format( L["%s Map %d : Difficulties and node counts per zone"],
			L["Herb"], addon.currTT ), "CENTER", numColumns )
	else
		-- its an ore tooltip. These are pretty custom, and less able to be automated like herbs
		if ( addon.currTT == 5 ) then
			tooltip:SetColumnLayout( 9, "LEFT", "CENTER", "CENTER", "CENTER", "LEFT", "CENTER",
				"CENTER", "CENTER", "CENTER" )
			tooltip:AddHeader( "a" ); tooltip:SetCell( 1, 1, MODNAME, "CENTER", 9 )
			tooltip:AddLine( " " ); tooltip:AddHeader( "b" )
			tooltip:SetCell( 3, 1, string.format( L["%s Map %d : Difficulties and node counts per zone"],
				L["Ore"], "1" ), "CENTER", 9 )
			--	[5] = "2770 2771 2772 3858 10620 rtv",
			local iconMap, skillMap, zoneData = {}, {}, {}
			iconMap[1] = " "; skillMap[1] = Orange( L["Skill"] )
			for i in string.gmatch( addon.ttOre[addon.currTT], "%S+") do
				if ( i == "rtv" ) then
					table.insert( iconMap, "|TInterface\\AddOns\\Broker_Extractor\\img\\" .. i .. ":48|t" )
					table.insert( skillMap, Orange( addon.nodeCounts[i]["skill"] ) )
				else
					local j = i + 0
					local itemName, _, _, _, _, _, _, _, _, icon = GetItemInfo(j)
					addon.Debug( i .. " : " .. icon )
					table.insert( iconMap, "|T" .. icon .. ":48|t" )
					table.insert( skillMap, Orange( addon.nodeCounts[j]["skill"] ) )
				end
				if ( i == "2771" ) then
					table.insert( iconMap, " " ); table.insert( iconMap, " " )
					table.insert( skillMap, " " ); table.insert( skillMap, Orange( L["Skill"] ) )
				end
			end
			tooltip:AddLine( unpack( iconMap ) )
			tooltip:AddLine( unpack( skillMap ) )
			local zoneIndex = 1
			for i in string.gmatch( addon.ttZones[51], "%d+") do
				zoneData[zoneIndex] = {}
				local j = i + 0
				table.insert( zoneData[zoneIndex], Pink( addon.ZoneMapping[j] ) )
				for k in string.gmatch( addon.ttOre[addon.currTT], "%S+" ) do
					local m = k + 0
					if ( addon.nodeCounts[m][j] ) then
						table.insert( zoneData[zoneIndex], addon.nodeCounts[m][j] )
					else
						table.insert( zoneData[zoneIndex], " " )
					end
					-- once we hit the separator, quit out
					if ( k == "2771" ) then
						table.insert( zoneData[zoneIndex], " " )
						break;
					end
				end
				zoneIndex = zoneIndex + 1
			end
			zoneIndex = 1
			for i in string.gmatch( addon.ttZones[52], "%d+") do
				local j = i + 0
				addon.Debug( "second columns, index = " .. i )
				table.insert( zoneData[zoneIndex], Pink( addon.ZoneMapping[j] ) )
				local go = false
				for k in string.gmatch( addon.ttOre[addon.currTT], "%S+" ) do
					if ( go == true ) then
						if ( k == "rtv" ) then
							if ( addon.nodeCounts[k][j] ) then
								table.insert( zoneData[zoneIndex], addon.nodeCounts[k][j] )
							else
								table.insert( zoneData[zoneIndex], " " )
							end
						else
							local m = k + 0
							if ( addon.nodeCounts[m][j] ) then
								table.insert( zoneData[zoneIndex], addon.nodeCounts[m][j] )
							else
								table.insert( zoneData[zoneIndex], " " )
							end
						end
					end
					if ( k == "2771" ) then
						go = true
					end
				end
				zoneIndex = zoneIndex + 1
			end
			for i = 1, ( zoneIndex - 1 ) do
				tooltip:AddLine( unpack( zoneData[i] ) )
			end
		else
			tooltip:SetColumnLayout( 10, "LEFT", "CENTER", "CENTER", "CENTER", "CENTER", "LEFT",
				"CENTER", "CENTER", "CENTER", "CENTER" )
			tooltip:AddHeader( "a" ); tooltip:SetCell( 1, 1, MODNAME, "CENTER", 10 )
			numColumns = 10
			tooltip:AddLine( " " ); tooltip:AddHeader( "b" )
			tooltip:SetCell( 3, 1, string.format( L["%s Map %d : Difficulties and node counts per zone"],
				L["Ore"], "2" ), "CENTER", 10 )
			-- [6] = "23424 23425 rad 36909 rcn 36912 rsn",
			local iconMap, skillMap, zoneData = {}, {}, {}
			iconMap[1] = " "; skillMap[1] = Orange( L["Skill"] )
			for i in string.gmatch( addon.ttOre[addon.currTT], "%S+") do
				if ( ( i == "rad" ) or ( i == "rcn" ) or ( i == "rsn" ) ) then
					table.insert( iconMap, "|TInterface\\AddOns\\Broker_Extractor\\img\\" .. i .. ":48|t" )
					addon.Debug( "ore2 skillmap entry : " .. i )
					table.insert( skillMap, Orange( addon.nodeCounts[i]["skill"] ) )
				else
					local j = i + 0
					local itemName, _, _, _, _, _, _, _, _, icon = GetItemInfo(j)
					addon.Debug( i .. " : " .. icon )
					table.insert( iconMap, "|T" .. icon .. ":48|t" )
					table.insert( skillMap, Orange( addon.nodeCounts[j]["skill"] ) )
				end
				if ( i == "rad" ) then
					table.insert( iconMap, " " ); table.insert( iconMap, " " )
					table.insert( skillMap, " " ); table.insert( skillMap, Orange( L["Skill"] ) )
				end
			end
			tooltip:AddLine( unpack( iconMap ) )
			tooltip:AddLine( unpack( skillMap ) )
			local zoneIndex = 1
			for i in string.gmatch( addon.ttZones[61], "%d+") do
				zoneData[zoneIndex] = {}
				local j = i + 0
				table.insert( zoneData[zoneIndex], Pink( addon.ZoneMapping[j] ) )
				for k in string.gmatch( addon.ttOre[addon.currTT], "%S+" ) do
					if ( k == "rad" ) then
						if ( addon.nodeCounts[k][j] ) then
							table.insert( zoneData[zoneIndex], addon.nodeCounts[k][j] )
						else
							table.insert( zoneData[zoneIndex], " " )
						end
						table.insert( zoneData[zoneIndex], " " )
						break;
					else
						local m = k + 0
						if ( addon.nodeCounts[m][j] ) then
							table.insert( zoneData[zoneIndex], addon.nodeCounts[m][j] )
						else
							table.insert( zoneData[zoneIndex], " " )
						end
					end
				end
				zoneIndex = zoneIndex + 1
			end
			zoneIndex = 1
			for i in string.gmatch( addon.ttZones[62], "%d+") do
				local j = i + 0
				addon.Debug( "second columns, index = " .. i )
				table.insert( zoneData[zoneIndex], Pink( addon.ZoneMapping[j] ) )
				local go = false
				for k in string.gmatch( addon.ttOre[addon.currTT], "%S+" ) do
					if ( go == true ) then
						if ( ( k == "rcn" ) or ( k == "rsn" ) ) then
							if ( addon.nodeCounts[k][j] ) then
								table.insert( zoneData[zoneIndex], addon.nodeCounts[k][j] )
							else
								table.insert( zoneData[zoneIndex], " " )
							end
						else
							local m = k + 0
							if ( addon.nodeCounts[m][j] ) then
								table.insert( zoneData[zoneIndex], addon.nodeCounts[m][j] )
							else
								table.insert( zoneData[zoneIndex], " " )
							end
						end
					end
					if ( k == "rad" ) then
						go = true
					end
				end
				zoneIndex = zoneIndex + 1
			end
			for i = 1, ( zoneIndex - 1 ) do
				tooltip:AddLine( unpack( zoneData[i] ) )
			end
		end
	end

	tooltip:AddLine(" ")
	local lineNum = tooltip:AddLine( "b" )
	tooltip:SetCell( lineNum, 1, L["Left-Click to cycle through maps"], "LEFT", numColumns )
	lineNum = tooltip:AddLine( "c" )
	tooltip:SetCell( lineNum, 1, L["Right-click for Configuration"], "LEFT", numColumns )
end

-- LDB stuff
local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( MODNAME, {
	type = "data source",
	text = "",
	label = FULLNAME,
	icon = "Interface\\Addons\\" .. FULLNAME .. "\\icon",
	OnClick = function( clickedframe, button )
				if button == "RightButton" then
					addon:ShowConfig()
				else
					advanceTip()
					drawTooltip()
					tooltip:SmartAnchorTo( clickedframe )
					tooltip:Show()
				end
	end,
	OnEnter = function ( self )
		drawTooltip()
		tooltip:EnableMouse()
		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( self )
		if MouseIsOver( tooltip ) then
			tooltip:SetScript( 'OnLeave', HideTooltip )
		else
			HideTooltip()
		end
	end,
} )

function addon.upgradeDB()
	local olddb = addon.db.factionrealm[addon.me]
	if ( olddb.options.display.dbVersion == "1.0" ) then
		-- original version
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.1"
		addon.Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
	if ( olddb.options.display.dbVersion == "1.1" ) then
		olddb.options.display.herb1 = true		
		olddb.options.display.herb2 = true		
		olddb.options.display.herb3 = true		
		olddb.options.display.herb4 = true		
		olddb.options.display.ore1 = true		
		olddb.options.display.ore2 = true		
		olddb.options.display.dbVersion = "1.2"
		addon.Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
	if ( olddb.options.display.dbVersion == "1.2" ) then
		olddb.options.display.disableitemtip = false
		olddb.options.display.dbVersion = "1.3"
		addon.Print( string.format( L["Database upgraded to %s"], "1.3" ) )
	end
end


-- options stuff
local displayOptions = nil
local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 2,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 21,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 22,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				sound = {
					order	= 23,
					type	= "toggle",
					name	= L["Enable DEBUG"],
					desc	= L["DISPLAY_DEBUG_DESC"],
					get		= function() return db.options.display.debug end,
					set		= function() db.options.display.debug = not db.options.display.debug end,
				},
				tooltipscale = {
					order	= 24,
					type	= "range",
					name	= L["Tooltip Scale"],
					desc	= L["TOOLTIP_SCALE_DESC"],
					min		= .7,
					max		= 1.3,
					step	= .05,
					bigStep = .05,
					get		= function() return db.options.display.tipscale end,
					set		= function( info, v ) 
								db.options.display.tipscale = v
								tooltip:SetScale( v )
							  end,
				},
				herb1 = {
					order	= 25,
					type	= "toggle",
					name	= L["Herb Set 1 Tooltip"],
					desc	= L["HERB1_TOGGLE_DESC"],
					get		= function() return db.options.display.herb1 end,
					set		= function() db.options.display.herb1 = not db.options.display.herb1 end,
				},
				herb2 = {
					order	= 26,
					type	= "toggle",
					name	= L["Herb Set 2 Tooltip"],
					desc	= L["HERB2_TOGGLE_DESC"],
					get		= function() return db.options.display.herb2 end,
					set		= function() db.options.display.herb2 = not db.options.display.herb2 end,
				},
				herb3 = {
					order	= 27,
					type	= "toggle",
					name	= L["Herb Set 3 Tooltip"],
					desc	= L["HERB3_TOGGLE_DESC"],
					get		= function() return db.options.display.herb3 end,
					set		= function() db.options.display.herb3 = not db.options.display.herb3 end,
				},
				herb4 = {
					order	= 28,
					type	= "toggle",
					name	= L["Herb Set 4 Tooltip"],
					desc	= L["HERB4_TOGGLE_DESC"],
					get		= function() return db.options.display.herb4 end,
					set		= function() db.options.display.herb4 = not db.options.display.herb4 end,
				},
				ore1 = {
					order	= 29,
					type	= "toggle",
					name	= L["Ore Set 1 Tooltip"],
					desc	= L["ORE1_TOGGLE_DESC"],
					get		= function() return db.options.display.ore1 end,
					set		= function() db.options.display.ore1 = not db.options.display.ore1 end,
				},
				ore2 = {
					order	= 30,
					type	= "toggle",
					name	= L["Ore Set 2 Tooltip"],
					desc	= L["ORE2_TOGGLE_DESC"],
					get		= function() return db.options.display.ore2 end,
					set		= function() db.options.display.ore2 = not db.options.display.ore2 end,
				},
				disableitemtip = {
					order	= 31,
					type	= "toggle",
					name	= L["Disable Item Tooltip Changes"],
					desc	= L["ITEMTT_DISABLE"],
					get		= function() return db.options.display.disableitemtip end,
					set		= function() db.options.display.disableitemtip = not db.options.display.disableitemtip end,
				},
			},
		}
	end
	return displayOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.display.dbVersion .. "\n",
						},
						translators = {
							order	= 16,
							type	= "description",
							name	= string.format( L["Helpful Translators (thank you) : %s"], " \n" )
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function addon:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

function addon.AddExtractData( tt, itemID, itemName, toggle )
	tt:AddLine( " " )
	local miner = {}
	if ( toggle == 1 ) then
		tt:AddLine( Brown( itemName .. L[" extracts into :"] ) )
		miner = addon.MinedData[itemID]
		if ( miner ~= nil ) then
			local times = miner.times
			local yields = miner.yielded
			table.sort( yields, function( a, b ) return a.times > b.times end )
			for k, v in pairs( yields ) do
				local oName, oPerc = "", ""
				local itemInfo = GetItemInfo( k )
				if ( itemInfo ~= nil ) then
					oName = "  " .. itemInfo
					if ( v.max ~= 1 ) then
						oName = oName .. "(" .. v.min .. "-" .. v.max .. ")"
					end
					if ( times ~= 0 ) then
						oPerc = string.format( "%.1f%%", ( v.times / times * 100 ) )
					else
						oPerc = "?"
					end
					tt:AddDoubleLine( Yellow( oName ), White( oPerc ) )
				end
			end
		else
			tt:AddLine( Brown( L["No Extraction Statistics Found"] ) )
		end
	else
		tt:AddLine( Brown( itemName .. L[" extracted from :"] ) )
		miner = addon.MinedResults[itemID]
		if ( miner ~= nil ) then
			for k, v in pairs( miner ) do
				local oName, oPerc = "", ""
				if ( v.max == 1 ) then
					oName = "  " .. GetItemInfo( k )
				else
					oName = "  " .. GetItemInfo( k ) .. "(" .. v.min .. "-" .. v.max .. ")"
				end
				if ( v.tries ~= 0 ) then
					oPerc = string.format( "%.1f%%", ( v.yields / v.tries * 100 ) )
				else
					oPerc = "?"
				end
				tt:AddDoubleLine( Yellow( oName ), White( oPerc ) )
			end
		else
			tt:AddLine( Brown( L["No Extraction Statistics Found"] ) )
		end
	end
	tt:AddLine( " " )
end

local Orig_GameTooltip_SetItem = GameTooltip:GetScript("OnTooltipSetItem")
GameTooltip:SetScript("OnTooltipSetItem", function( tooltip, ... )
	if ( db.options.display.disableitemtip == false ) then
		if Orig_GameTooltip_SetItem then
			Orig_GameTooltip_SetItem( tooltip, ... )
		end
		if ( tooltip ) then
			local name, link = tooltip:GetItem()
			if ( link ) then
				local itemID = string.match( link, "item:(%d+)" ) + 0
				if ( addon.Extractables[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 1 )
				elseif( addon.Extracteds[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 0 )
				end
			end
		end
	end
end)

local Orig_ItemRefTooltip_SetItem = ItemRefTooltip:GetScript("OnTooltipSetItem")
ItemRefTooltip:SetScript("OnTooltipSetItem", function(tooltip, ...)
	if ( db.options.display.disableitemtip == false ) then
		if Orig_ItemRefTooltip_SetItem then
			Orig_ItemRefTooltip_SetItem(tooltip, ...)
		end
		if ( tooltip ) then
			local name, link = tooltip:GetItem()
			if ( link ) then
				local itemID = string.match( link, "item:(%d+)" ) + 0
				if ( addon.Extractables[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 1 )
				elseif( addon.Extracteds[itemID] == true ) then
					addon.AddExtractData( tooltip, itemID, name, 0 )
				end
			end
		end
	end
end)

local function stopScanning()
	if (Extractor_ScanLinksFrame) then
		Extractor_ScanLinksFrame:SetScript("OnUpdate", nil);
	end
	addon.Print( L["Item scanning completed."] )
end

function addon.scanItems()
	-- This code, while modified, is largely ripped straight from Xinhuan's wowequip
	-- Used by permission. Thanks Xinhuan!
	--
	-- my IDs to scan are going to be in addon.scanAll
	-- shove through them all, and see which ones pop up as unknown. put those in a new
	-- linear indexed table
	local scanTable = {}
	for i in string.gmatch( addon.scanAll, "%d+") do
		if not GetItemInfo(i) then
			table.insert( scanTable, i )
		end
	end
	addon.Debug( "size of scan table is " .. #scanTable )

	if ( #scanTable ~= 0 ) then
		addon.Print( string.format( L["%d Extractor items are not in your local cache."], #scanTable ) )
		addon.Print( L["Beginning item scanning now..."] )

		local lastScannedIndex = 1;
		local totalElapsed = 0;

		if (not Extractor_ScanLinksFrame) then
			Extractor_ScanLinksFrame = CreateFrame("Frame")
			Extractor_ScanLinksTooltip = CreateFrame("GameTooltip", "Extractor_ScanLinksTooltip", nil, "GameTooltipTemplate")
			Extractor_ScanLinksTooltip:SetOwner(WorldFrame, "ANCHOR_NONE")
		end

		Extractor_ScanLinksFrame:SetScript("OnUpdate", function(self, elapsed)
			-- Yes, this creates a function closure with upvalues
			totalElapsed = totalElapsed + elapsed;
			if totalElapsed < 10 then
				return;
			end
			totalElapsed = 0;
			local currScan = scanTable[lastScannedIndex]
			addon.Debug( "... currently scanning : " .. currScan .. " at index : " .. lastScannedIndex )
			if ( currScan ) then
				Extractor_ScanLinksTooltip:SetHyperlink("item:"..currScan)
			end
			if ( lastScannedIndex == #scanTable ) then
				stopScanning()
			else
				lastScannedIndex = lastScannedIndex + 1	
			end
			return
		end )
	end
end

function addon:OnInitialize()
	-- Do Frame Creation stuff here
	-- addon:CreateFrames()
end

function addon:OnEnable()
    -- Called when the addon is loaded
	addon.me = UnitName( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( MODNAME .. "_DB", nil, "Default" )
	-- do we have any data yet; for this toon? If not, init its table
	if not ( self.db.factionrealm[addon.me] ) then
		self.db.factionrealm[addon.me] = {
		-- Your saved variables stuff here
			options = {
				display = {
					debug = false,
					tipscale = 1,
					dbVersion = "1.3",
					herb1 = true,
					herb2 = true,
					herb3 = true,
					herb4 = true,
					ore1 = true,
					ore2 = true,
					disableitemtip = false,
				},
			},
		}
	else
		-- check if we need to upgrade the db
		addon.upgradeDB()
	end
	db = self.db.factionrealm[addon.me]

	addon.Debug( "In OnInit" )

	-- start up item scanning until everything is in cache
	addon.scanItems()

	-- tooltip setup and scaling
	tooltip = LTT:Acquire( MODNAME.."TT", 3, "LEFT", "CENTER", "RIGHT" ) -- or GameTooltip
	tooltip:SetScale( db.options.display.tipscale )

	addon:SetupOptions()
	-- Event listeners
    -- addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	advanceTip()
end

--[[
************************************************************************
CHANGELOG:

11/20/08 : 
	Initial version
************************************************************************
]]--